package cn.com.infosec.mobile.android.framework.crypto;

import cn.com.infosec.mobile.android.framework.crypto.impl.SoftImpl;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

public class HSM {
   public static final String CUSTOM_HSM = "_custom_hsm_";
   private static IHSM defaultImpl = new SoftImpl();
   private static Map<String, IHSM> hsms = new HashMap();
   private static Properties hsmDescriptor = new Properties();
   private static Map<String, String[]> gmSupportedSymAlg = new HashMap();

   public static IHSM getInst(String hsmType) {
      if (hsmType != null && hsmType.length() != 0) {
         if (hsms.containsKey(hsmType)) {
            return (IHSM)hsms.get(hsmType);
         } else {
            String var10000;
            if (hsmType.startsWith("_custom_hsm_")) {
               var10000 = hsmType.substring(12);
            } else {
               if (!hsmDescriptor.containsKey(hsmType)) {
                  throw new CryptoException("HSM [" + hsmType + "] NOT support.");
               }

               var10000 = hsmDescriptor.getProperty(hsmType);
            }

            Exception var5;
            label44: {
               boolean var10001;
               IHSM var6;
               try {
                  var6 = (IHSM)Class.forName(var10000).newInstance();
               } catch (Exception var3) {
                  var5 = var3;
                  var10001 = false;
                  break label44;
               }

               IHSM var1;
               IHSM var7 = var1 = var6;

               try {
                  var7.setSupportedSymAlg_GM((String[])gmSupportedSymAlg.get(hsmType));
                  hsms.put(hsmType, var1);
                  return var6;
               } catch (Exception var2) {
                  var5 = var2;
                  var10001 = false;
               }
            }

            Exception hsmType1 = var5;
            throw new CryptoException(hsmType1);
         }
      } else {
         return defaultImpl;
      }
   }

   public static String[] getSupportedHSM() {
      Set var10000 = hsmDescriptor.keySet();
      String[] var0 = new String[var10000.size()];
      int var1 = 0;

      int var10001;
      Object var10002;
      for(Iterator var2 = var10000.iterator(); var2.hasNext(); var0[var10001] = (String)var10002) {
         var10001 = var1;
         var10002 = var2.next();
         ++var1;
      }

      return var0;
   }
}
